# read from mat file
import h5py
import hdf5storage
import os
import numpy as np
import urllib, json

data_path = 'PavementSamplePoint.mat' # meta data created from ground truth csv file.
save_path = '' # path to store images
gt_path = '' # path to store groundtruth

progid = 1 # index of the process, used when you run this script multi times at the same time

def loadLabel(path):
    with h5py.File(path) as f:
        sd = np.array(f['sd'])
        sd = sd.squeeze()
        sp = [f[x[0]][:] for x in f['sp']]
    return sd, sp

def fetchImg(vgeo, vd):
    # test if the image exists at this location
    global panoId
    global idxInSeg
    lat = str(vgeo[0])
    lon = str(vgeo[1])
    url = ''.join(('https://maps.googleapis.com/maps/api/streetview/metadata?size=640x640&location=',
                    lat, ',', lon,
                    '&fov=90&heading=',
                    str(vd),
                    '&pitch=-50&key=',
                    keyId))
    # url = ''.join(('http://maps.google.com/cbk?output=json&hl=en&ll=', lat, ',', lon, '&radius=20&cb_client=maps_sv&v=4'))
    response = urllib.urlopen(url)
    data = json.loads(response.read())
    if data['status'] != 'OK' or ('date' not in data):
        return (0,)
    else:
        pid = data['pano_id']
        # same image if pid is the same as the previous location. Do nothing
        if pid != panoId:
            panoId = pid
            # read and save image
            # vdlist = [vd, vd + 90, vd + 180, vd + 270]
            # d = vd
            # for d in vdlist:
            url = ''.join(('https://maps.googleapis.com/maps/api/streetview?size=640x640&location=',
                            lat, ',', lon,
                            '&fov=90&heading=',
                            str(vd),
                            '&pitch=-50&key=',
                            keyId))
            fname = ''.join((str(segId), '_', str(idxInSeg), '.jpg'))
            # segIdList.append(segId)
            # idxInSegList.append(idxInSeg)
            # nameList.append(fname)

            urllib.urlretrieve(url, ''.join((spath, fname)))
            idxInSeg = idxInSeg + 1
            return (1, segId, idxInSeg - 1, data['date'].encode('ascii','ignore'))
        else:
            return (0,)


sd, sp = loadLabel(data_path)
segId = 1 # index of segment
idxInSeg = 1 # index of the image in the segment
keyId = '' # use your google street view token. Please follow the API instruction from Google to obtain
panoId = ''

# segIdList = []
# idxInSegList = []
# nameList = []

datelist = []
for m in range(progid * 1000, (progid + 1) * 1000):
    segId = m + 1
    vd = sd[m]
    geolist = sp[m]
    idxInSeg = 1
    fdId = m / 1000 + 1
    spath = ''.join((save_path, str(fdId), '/'))
    if not os.path.exists(spath):
        os.makedirs(spath)

    for n in range(len(geolist)):
        fdata = fetchImg(geolist[n], vd)
        if fdata[0]: # success
            datelist.append(fdata[1 : ])
    print m

hdf5storage.savemat(''.join((spath, 'imgdate.mat')), {u'date': datelist})
    # datatable[u'segId'] = np.array(segIdList, dtype=np.object)
    # datatable[u'idxInSeg'] = np.array(idxInSegList, dtype=np.object)
    # datatable[u'fname'] = np.array(nameList, dtype=np.object)
    # hdf5storage.write(datatable, filename='121_1000.mat', matlab_compatible=True)





